Subject: Re: [PATCH net-next v10 04/11] net: ti: prueth: Adds link detection, RX and TX support.

From: Jakub Kicinski <[email-masked]>
Date: Wed, 16 Jul 2025 14:09:26 -0700

On Wed, 16 Jul 2025 18:41:11 +0530 (IST) Parvathi Pudi wrote:
> >> Something needs to stop the queue, right? Otherwise the stack will
> >> send the frame right back to the driver.
> > 
> > Yes, we will notify upper layer with “netif_tx_stop_queue()” when returning
> > “NETDEV_TX_BUSY” to not push again immediately.
> 
> We reviewed the flow and found that the reason for NETDEV_TX_BUSY being
> notified to the upper layers is due lack of support for reliably detecting
> the TX completion event.
> 
> In case of ICSSM PRU Ethernet, we do not have support for TX complete
> notification back to the driver from firmware and its like store and
> forget approach. So it will be tricky to enable back/resume the queue
> if we stop it when we see busy status.

IIUC this is all implemented in SW / FW. You either need to add 
the notification or use a timer to unblock the queue.